/************************************************************************/
/* FDB520 LIB                                                           */
/* Ver 1.0																*/
/* Last Edited:1395/06/16                                               */
/* Abolfazl Shakeri                                                     */
/* Designer2013.blogsky.com                                             */
/************************************************************************/
#ifndef _FP_LIB_H
#define _FP_LIB_H

#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <string.h>
#include "compiler.h"
#include "uart_ATX.h"
/************************************************************************/
/* EDIT THIS DEFINE's                                                   */
/************************************************************************/
//#define DEBUGE_FP

#define FP_select_uart		uartE0
#define FP_UART				&USARTE0
#define FP_UART_ISR			USARTE0_RXC_vect

#ifdef DEBUGE_FP
#define dbg_uart_fp			uartF0
#define DBG_UART_FP			&USARTF0
#endif
/************************************************************************/
/* DONT EDIT THIS DEFINE's                                              */
/************************************************************************/
#define serch_no			0
#define serch_start			1
#define serch_comlet		2
#define serch_ERR			3		

#define serch_timeout		10
#define serch_error			11
#define last_added			12
#define addr_full			13
#define mem_empty			14
#define not_finde			15
#define mem_overflow		16
#define	del_error			17
#define add_error			18


#define fp_length			25
struct
{
	char buffer[fp_length+1],recive;
	int index,id,respons;
}fp;

char buffer_fp[20],serch_state;
int fp_timeout;

void fp_init();
void detect_fp();
void empty_finger();
char add_finger(int finger_number);
char delet_finger(int finger_number);
void serch_finger();
char serch_finger_wait();

void fp_init()
{
	uart_init(FP_UART,FP_select_uart,baud_9600,conf_8_no_1);
	uart_interrupt_init(FP_UART,medium_level_interrupt);

	#ifdef DEBUGE_FP
	uart_init(DBG_UART_FP,dbg_uart_fp,baud_115200,conf_8_no_1);
	#endif

	//PMIC.CTRL |= PMIC_MEDLVLEN_bm;
	
	uart_put_string("AT",FP_UART,1);
}

void empty_finger()
{
	uart_put_string("AT",FP_UART,1);
	_delay_ms(500);
	#ifdef DEBUGE_FP
	uart_put_string("AT+DELALL",DBG_UART_FP,1);
	#endif
	uart_put_string("AT+DELALL",FP_UART,1);
}

char add_finger(int finger_number)
{
	memset(buffer_fp,0,20);
	fp.recive = DISABLE;
	sprintf(buffer_fp,"AT+ADD=%04d",finger_number);
	#ifdef DEBUGE_FP
	uart_put_string(buffer_fp,DBG_UART_FP,1);
	#endif
	uart_put_string(buffer_fp,FP_UART,1);
	fp_timeout=10000;fp.recive=0;
	while(fp_timeout && !fp.recive){fp_timeout--;_delay_ms(1);}
	
	if (fp.recive==ENABLE)		return fp.respons;
	else						return FALSE;
}

char serch_finger_wait()
{
	memset(buffer_fp,0,20);
	fp.id = 0;
	fp.recive = DISABLE;
	sprintf(buffer_fp,"AT+CHECK");
	#ifdef DEBUGE_FP
	uart_put_string(buffer_fp,DBG_UART_FP,1);
	#endif
	uart_put_string(buffer_fp,FP_UART,1);
	fp_timeout=10000;fp.recive=0;
	while(fp_timeout && !fp.recive){fp_timeout--;_delay_ms(1);}
	if (fp.buffer[0]=='I' && fp.buffer[1]=='D')
	{
		return fp.id;
	}
	if (fp.recive==ENABLE)		return fp.respons;
	else						return FALSE;
}

void serch_finger()
{
	memset(buffer_fp,0,20);
	fp.id = 0;
	fp.recive = DISABLE;
	fp.respons = DISABLE;
	serch_state = serch_start;
	sprintf(buffer_fp,"AT+CHECK");
	#ifdef DEBUGE_FP
	uart_put_string(buffer_fp,DBG_UART_FP,1);
	#endif
	uart_put_string(buffer_fp,FP_UART,1);
}

char delet_finger(int finger_number)
{
	uart_put_string("AT",FP_UART,1);
	_delay_ms(500);
	memset(buffer_fp,0,20);
	sprintf(buffer_fp,"AT+DEL=%04d",finger_number);
	#ifdef DEBUGE_FP
	uart_put_string(buffer_fp,DBG_UART_FP,1);
	#endif
	fp.recive = DISABLE;
	uart_put_string(buffer_fp,FP_UART,1);
	fp_timeout=10000;fp.recive=0;
	while(fp_timeout && !fp.recive){fp_timeout--;_delay_ms(1);}
	if (fp.recive==ENABLE)		return fp.respons;
	else						return FALSE;
}

void detect_fp()
{
	#ifdef DEBUGE_FP
	uart_put_string(fp.buffer,DBG_UART_FP,1);
	#endif
	if(strstr(fp.buffer,"ID")!=0)
	{
		if(serch_state==serch_start)serch_state=serch_comlet;
		memset(buffer_fp,0,20);
		buffer_fp[0]=fp.buffer[2];
		buffer_fp[1]=fp.buffer[3];
		buffer_fp[2]=fp.buffer[4];
		buffer_fp[3]=fp.buffer[5];
		fp.id = atoi(buffer_fp);
		return;
	}
	else if(strstr(fp.buffer,"Err")!=0)
	{
		if(serch_state==serch_start)serch_state = serch_ERR;
		if(strstr_P(fp.buffer,PSTR("Err0"))!=0){fp.respons = mem_empty;}
		else if(strstr_P(fp.buffer,PSTR("Err1"))!=0){fp.respons = mem_overflow;}
		else if(strstr_P(fp.buffer,PSTR("Err2"))!=0){fp.respons = serch_timeout;}
		else if(strstr_P(fp.buffer,PSTR("Err3"))!=0){fp.respons = add_error;}
		else if(strstr_P(fp.buffer,PSTR("Err4"))!=0){fp.respons = last_added;}
		else if(strstr_P(fp.buffer,PSTR("Err5"))!=0){fp.respons = not_finde;}
		else if(strstr_P(fp.buffer,PSTR("Err6"))!=0){fp.respons = serch_error;}
		else if(strstr_P(fp.buffer,PSTR("Err8"))!=0){fp.respons = del_error;}
		else if(strstr_P(fp.buffer,PSTR("Err9"))!=0){fp.respons = addr_full;}
		return;
	}
	else if(strstr_P(fp.buffer,PSTR("OK"))!=0)
	{
		fp.respons = TRUE;
		return;
	}
	else if (strstr(fp.buffer,"R30x")!=0)
	{
		#ifdef DEBUGE_FP
			uart_put_string("**FP_OK**",DBG_UART_FP,1);
		#endif
	}
	else
	{
		serch_state = serch_no;
	}
}

//--------------------------------------
ISR(FP_UART_ISR)
{
	fp.buffer[fp.index]=uart_getchar(FP_UART);
	if(fp.index==0){fp.recive=DISABLE;}
	if (fp.buffer[fp.index]=='\r')
	{
		for (fp.index=fp.index; fp.index<fp_length; fp.index++)
		{
			fp.buffer[fp.index]=0;
		}
		fp.index = 0;
		detect_fp();
		fp.recive=ENABLE;
	}
	else if(fp.index < fp_length-1){fp.index++;}
}
//--------------------------------------
#endif